%define		own	asterisk
%define		grp	asterisk
%define		sown	root
%define		sgrp	root
%define		rawname	pm2

Name:		freepbx-%{rawname}
Version:	16.0.8
Release:	1%{?dist}
Summary:	Process Management

License:	See Freepbx Readme
Source0:	https://mirror.freepbx.org/modules/packages/%{rawname}/%{rawname}-%{version}.tgz
Patch0:		freepbx-pm2.noinst.nochown.nochmod.patch

BuildRequires:  npm
Provides:	freepbx-%{rawname} = %{version}-%{release}

BuildArch:	noarch

%description
This module manages background processes for your PBX

%prep
%setup -q -n %{rawname}
%patch0 -p0

# Controlliamo la eventuale presenza di particolarita' da gestire
for ddd in agi-bin bin sbin etc astetc images assets sounds moh hooks ; do
	[ -e $ddd ] && echo presente $ddd, va gestito && exit 1
done

# Non mi va di lanciare gpg a destra e a manca, solo per venire a sapere che ho modificato i moduli
%{__rm} module.sig

# Delete backup files
find . -name '*.orig' -exec rm '{}' ';'
find . -depth -name '.git*' -exec rm -rf '{}' ';'

# fix dir perms
find . -type d -exec chmod 755 '{}' ';'
find . -type f -exec chmod 644 '{}' ';'
#find . -type f -regex '.*\.\(php\|html\)$' -exec chmod 644 '{}' ';'

echo -n 'prefix = "~/.node"' > node/.npmrc
/bin/bash -c 'cd node &&
mkdir -p .pm2 &&
mkdir -p logs &&
export HOME=$PWD &&
export PM2_HOME=$HOME/.pm2 &&
export ASTLOGDIR=/var/log/asterisk &&
export ASTVARLIBDIR=/usr/share/asterisk &&
export PATH=$HOME/.node/bin:$PATH &&
export NODE_PATH=$HOME/.node/lib/node_modules:$NODE_PATH &&
export MANPATH=$HOME/.node/share/man:$MANPATH &&
echo "+ npm install -g npm-cache" &&
npm install -g npm-cache --loglevel verbose &&
echo "+ npm-cache -v" &&
npm-cache -v &&
echo "+ npm-cache install --only=production" &&
npm-cache install --only=production &&
echo "+ ./node_modules/pm2/bin/pm2 update" &&
./node_modules/pm2/bin/pm2 update &&
echo "+ ./node_modules/pm2/bin/pm2 ping" &&
./node_modules/pm2/bin/pm2 ping &&
echo "+ ./node_modules/pm2/bin/pm2 kill" &&
./node_modules/pm2/bin/pm2 kill
'

# Delete cache and other metaresults I think are not needed
rm -rf node/{.package_cache,.npm,dump.pm2}
rm -rf node/.node	# Vediamo se corretto, mi sembrano tutte cache. La distro lo mette in ~/asterisk, ma suppongo xche loro fanno build li'
rm -rf node/.cache	# Vediamo se corretto, mi sembrano tutte cache. La distro lo mette in ~/asterisk, ma suppongo xche loro fanno build li'

# Correggiamo i percorsi - verificare che alla fine sia coerente con il dove li metteremo
#find node/.node/lib/node_modules node/node_modules -type f -exec perl -pi -e 's-/home/builder/rpmbuild/BUILD/pm2/node-/usr/share/freepbx/admin/modules/pm2/node-' '{}' ';'
find node/node_modules -type f -exec perl -pi -e 's-/home/builder/rpmbuild/BUILD/%{rawname}/node-/usr/share/freepbx/admin/modules/%{rawname}/node-' '{}' ';'

# Correggiamo uno shabang in un file di esempio, che vorrebbe un programma che non abbiamo e non avremo mai.
perl -pi -e '$. == 1 and s|/sbin/openrc-run|/bin/sh|' node/node_modules/pm2/lib/templates/init-scripts/openrc.tpl 

%install
%{__install} -d %{buildroot}%{_datadir}/freepbx/admin/modules/%{rawname}
%{__cp} -aR `ls | egrep -v '^(agi-bin|bin|etc|sounds|moh|images|LICENSE|README.md)'` %{buildroot}%{_datadir}/freepbx/admin/modules/%{rawname}
%{__install} -d %{buildroot}%{_datadir}/freepbx/admin/modules/%{rawname}/node/logs

%{__install} -d %{buildroot}%{_localstatedir}/lib/asterisk
%{__mv} %{buildroot}%{_datadir}/freepbx/admin/modules/%{rawname}/node/{.pm2,.npmrc} %{buildroot}%{_localstatedir}/lib/asterisk/

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%doc README.md
%defattr(0644,%{sown},%{sgrp},0755)

%{_datadir}/freepbx/admin/modules/%{rawname}
# %esclude sui files esclude proprio il file, non viene pacchettizzato (suppongo faccia lo stesso con le dir, e non sarebbe propio ideale, dato che poi lo usi x dare attributi specifici)
#%exclude %{_datadir}/freepbx/admin/modules/%{rawname}/node/node_modules/pm2/bin/pm2
%attr(0755,%{sown},%{sgrp}) %{_datadir}/freepbx/admin/modules/%{rawname}/node/node_modules/pm2/bin/pm2
%attr(0755,%{own},%{grp}) %{_datadir}/freepbx/admin/modules/%{rawname}/node/logs
# il reload prova a riscriverlo
%attr(0644,%{own},%{grp}) %{_localstatedir}/lib/asterisk/.npmrc
%attr(-,%{own},%{grp}) %{_localstatedir}/lib/asterisk/.pm2
#%attr(0644,%{own},%{grp}) %{_localstatedir}/lib/asterisk/.pm2/pm2.log

%changelog
* Mon Feb 28 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.8
- Updated version

* Fri Feb 04 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.6
- Updated version

* Sat Jan 22 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.5
- correct shabang of a template file, from /sbin/openrc-run to /bin/sh

* Wed Jan 19 2022 Luigi Iotti <asterisk@iotti.biz> - 16.0.5
- Initial build
